"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.default=toJSS;var _parse=require("css/lib/parse");var _parse2=_interopRequireDefault(_parse);var _toCamelCase=require("to-camel-case");var _toCamelCase2=_interopRequireDefault(_toCamelCase);var _lodash=require("lodash.get");var _lodash2=_interopRequireDefault(_lodash);var _lodash3=require("lodash.set");var _lodash4=_interopRequireDefault(_lodash3);var _utils=require("./utils");var _utils2=_interopRequireDefault(_utils);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function toJSS(css){var stylesheetString=Array.isArray(css)?css[0]:css;var directions=['top','right','bottom','left'];var changeArr=['margin','padding','border-width','border-radius'];var numberize=['width','height','font-size','line-height'].concat(directions);var specialProperties={};['border','border-top','border-right','border-bottom','border-left'].forEach(function(name){specialProperties[name]={regex:/^\s*([0-9]+)(px)?\s+(solid|dotted|dashed)?\s*([a-z0-9#,\(\)\.\s]+)\s*$/i,map:{1:name+"-width",3:name==='border'?name+"-style":null,4:name+"-color"}};});directions.forEach(function(dir){numberize.push("border-"+dir+"-width");changeArr.forEach(function(prop){numberize.push(prop+"-"+dir);});});var directionMaps={'border-radius':{Top:'top-left',Right:'top-right',Bottom:'bottom-right',Left:'bottom-left'}};function directionToPropertyName(property,direction){var names=property.split('-');names.splice(1,0,directionMaps[property]?directionMaps[property][direction]:direction);return(0,_toCamelCase2.default)(names.join('-'));}var unsupported=['display'];var nonMatching={'flex-grow':'flex','text-decoration':'textDecorationLine','vertical-align':'textVerticalAlign'};var _ParseCSS=(0,_parse2.default)(_utils2.default.clean(stylesheetString)),stylesheet=_ParseCSS.stylesheet;var JSONResult={};for(var _iterator=stylesheet.rules,_isArray=Array.isArray(_iterator),_i=0,_iterator=_isArray?_iterator:_iterator[typeof Symbol==="function"?Symbol.iterator:"@@iterator"]();;){var _ref;if(_isArray){if(_i>=_iterator.length)break;_ref=_iterator[_i++];}else{_i=_iterator.next();if(_i.done)break;_ref=_i.value;}var rule=_ref;if(rule.type!=='rule')continue;for(var _iterator2=rule.selectors,_isArray2=Array.isArray(_iterator2),_i2=0,_iterator2=_isArray2?_iterator2:_iterator2[typeof Symbol==="function"?Symbol.iterator:"@@iterator"]();;){var _ref2;if(_isArray2){if(_i2>=_iterator2.length)break;_ref2=_iterator2[_i2++];}else{_i2=_iterator2.next();if(_i2.done)break;_ref2=_i2.value;}var selector=_ref2;selector=selector.replace(/\.|#/g,'');var styles=void 0;var composedSelector=selector.match(/\s+(\S)+/g);if(composedSelector){var selectorPath=selector.match(/^\S+/)[0];while(composedSelector.length){var currentSelector=composedSelector.shift().replace(/\s+/,'');selectorPath+="["+currentSelector+"]";}if(!(0,_lodash2.default)(JSONResult,selectorPath)){(0,_lodash4.default)(JSONResult,selectorPath,{});}styles=(0,_lodash2.default)(JSONResult,selectorPath);}else{styles=JSONResult[selector]=JSONResult[selector]||{};}for(var _iterator3=rule.declarations,_isArray3=Array.isArray(_iterator3),_i3=0,_iterator3=_isArray3?_iterator3:_iterator3[typeof Symbol==="function"?Symbol.iterator:"@@iterator"]();;){var _ref3;if(_isArray3){if(_i3>=_iterator3.length)break;_ref3=_iterator3[_i3++];}else{_i3=_iterator3.next();if(_i3.done)break;_ref3=_i3.value;}var declaration=_ref3;if(declaration.type!=='declaration')continue;var value=declaration.value;var property=declaration.property;if(specialProperties[property]){var special=specialProperties[property];var matches=special.regex.exec(value);if(matches){if(typeof special.map==='function'){special.map(matches,styles,rule.declarations);}else{for(var key in special.map){if(matches[key]&&special.map[key]){rule.declarations.push({property:special.map[key],value:matches[key],type:'declaration'});}}}continue;}}if(_utils2.default.arrayContains(property,unsupported))continue;if(nonMatching[property]){rule.declarations.push({property:nonMatching[property],value:value,type:'declaration'});continue;}if(_utils2.default.arrayContains(property,numberize)){var valueReplaced=value.replace(/px|\s*/g,'');styles[(0,_toCamelCase2.default)(property)]=parseFloat(valueReplaced);}else if(_utils2.default.arrayContains(property,changeArr)){var values=value.replace(/px/g,'').split(/[\s,]+/);values.forEach(function(v,index,arr){arr[index]=parseInt(v);return arr;});var length=values.length;if(length===1){styles[(0,_toCamelCase2.default)(property)]=values[0];}if(length===2){var _arr=['Top','Bottom'];for(var _i4=0;_i4<_arr.length;_i4++){var prop=_arr[_i4];styles[directionToPropertyName(property,prop)]=values[0];}var _arr2=['Left','Right'];for(var _i5=0;_i5<_arr2.length;_i5++){var _prop=_arr2[_i5];styles[directionToPropertyName(property,_prop)]=values[1];}}if(length===3){var _arr3=['Left','Right'];for(var _i6=0;_i6<_arr3.length;_i6++){var _prop2=_arr3[_i6];styles[directionToPropertyName(property,_prop2)]=values[1];}styles[directionToPropertyName(property,'Top')]=values[0];styles[directionToPropertyName(property,'Bottom')]=values[2];}if(length===4){var index=0;var _arr4=['Top','Right','Bottom','Left'];for(var _i7=0;_i7<_arr4.length;_i7++){var _prop3=_arr4[_i7];styles[directionToPropertyName(property,_prop3)]=values[index];index++;}}}else{if(!isNaN(declaration.value)&&property!=='font-weight'){declaration.value=parseFloat(declaration.value);}styles[(0,_toCamelCase2.default)(property)]=declaration.value;}}}}return JSONResult;}
//# sourceMappingURL=toJSS.js.map